<template>
  <nav class="navbar navbar-expand-lg navbar-dark bg-dark">
    <a class="navbar-brand" @click="index">Goneslive</a>
    <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarText" aria-controls="navbarText" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>
    <div class="collapse navbar-collapse" id="navbarText">
      <ul class="navbar-nav mr-auto">
        <li class="nav-item active">
          <a class="nav-link" @click="index">Accueil<span class="sr-only">(current)</span></a>
        </li>
        <li v-if="user.data" class="nav-item">
          <a class="nav-link" @click="createProject">Créer un projet</a>
        </li>
      </ul>
      <span class="navbar-text">
        <div v-if="user.data" class="dropdown">
        <gravatar src="" :email="user.data.email" class="dropdown-toggle rounded" href="#" role="button" id="userMenu" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" :size="50"/>
        <div class="dropdown-menu" aria-labelledby="userMenu">
          <a class="dropdown-item" href="#">Mes projets</a>
          <a class="dropdown-item" @click="settings">Mes paramètres</a>
          <a class="dropdown-item" @click="signOut" href="#">Se déconnecter</a>
        </div>
      </div>
      <ul v-else class="navbar-nav mr-auto">
        <li class="nav-item">
          <button
            class="btn btn-login"
            @click="login"
          >Se connecter</button>
        </li>
        <li class="nav-item">
          <button
            class="btn btn-login"
            @click="register"
          >S'inscrire</button>
        </li>
      </ul>
    </span>
    </div>
  </nav>
</template>

<script>
import Gravatar from 'vue-gravatar'
import { mapGetters } from 'vuex'
import { db } from '../main'

export default {
  name: 'AppHeader',
  components: { Gravatar },
  computed: {
    // map `this.user` to `this.$store.getters.user`
    ...mapGetters({
      user: 'user'
    })
  },
  methods: {
    index: function () {
      this.$router.push('/')
    },
    createProject: function () {
      this.$router.push('/projects/create')
    },
    login: function () {
      this.$router.push('/sign-in')
    },
    register: function () {
      this.$router.push('/sign-up')
    },
    settings: function () {
      this.$router.push('/settings')
    },
    signOut: function () {
      db
        .auth()
        .signOut()
        .then(() => {
          this.$router.replace({
            name: 'home'
          })
        })
    }
  }
}
</script>

<style scoped>
  .bg-dark {
    background-color: #15202b !important;
  }
  a {
   cursor: pointer;
  }
  .btn.btn-login {
    background-color: rgba(34, 150, 146, 0.5);
    color: white;
    transition: 0.3s;
    margin-right: 1rem;
  }

  .btn.btn-login:hover {
    background-color: rgb(34, 150, 146);
    transition: 0.3s;
   }

  .dropdown-menu {
    background-color: #18191c !important;
    left: -200px;
    right: 0;
  }
  .dropdown-item:hover {
    background-color: #2C2E34 !important;
  }
</style>
